﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.RadControlSpy;

namespace Samples40
{
    public partial class Form74 : Form
    {
        public Form74()
        {
            InitializeComponent();
            new RadControlSpyForm().Show();
            for (int i = 0; i < 100; i++)
            {
                this.radListView1.Items.Add(i + ".", "Item " + i, "data", i);
            }

            this.radListView1.CellCreating += new Telerik.WinControls.UI.ListViewCellElementCreatingEventHandler(radListView1_CellCreating);
        }

        void radListView1_CellCreating(object sender, Telerik.WinControls.UI.ListViewCellElementCreatingEventArgs e)
        {
            DetailListViewDataCellElement dataCell = e.CellElement as DetailListViewDataCellElement;

            if (dataCell != null && dataCell.Data == this.radListView1.Columns[3])
            {
                e.CellElement = new ProgressBarCellElement(dataCell.RowElement, dataCell.Data);
            }

            if (e.CellElement is DetailListViewHeaderCellElement)
            {
                e.CellElement.BackColor = Color.White;
                e.CellElement.GradientStyle = Telerik.WinControls.GradientStyles.Solid;
            }
        }
    }

    public class ProgressBarCellElement : DetailListViewDataCellElement
    {
        private RadProgressBarElement progressBar;

        public ProgressBarCellElement(DetailListViewVisualItem owner, ListViewDetailColumn column)
            : base(owner, column)
        {

        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            this.progressBar = new RadProgressBarElement();
            this.progressBar.StretchHorizontally = this.progressBar.StretchVertically = true;

            this.Children.Add(this.progressBar);
        }

        public override void Synchronize()
        {

            base.Synchronize();
            this.Text = "";

            try
            {
                this.progressBar.Value1 = Convert.ToInt32(this.Row[this.column]);
            }
            catch { }

        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return base.ThemeEffectiveType;
            }
        }
    }
}
